#include "process.h"
#include "fd.h"

/*******************************************************/
/* generic virtual process handling                    */
/* specific virtual processes have their own vp_*.[ch] */
/*******************************************************/

/* call this once from main, before any lookup to initialize the hash */
void vp_init(void);

/* uninitialize the hash when it's not needed anymore */
void vp_uninit(void);

/* allocate a new virtual process cmd called id with args; returns NULL if
   cmd is not a valid virtual process name */
proc_virt_t *vp_alloc(transaction_t *tx, char *cmd, const char *id, kvlist_t *args);

/* free resources allocated by vp_alloc(); p->free is called before this call */
void vp_free(proc_virt_t *p);

/* set up default event handlers for a virtual process */
void vp_default(proc_virt_t *proc);

/* act as ret says; useful for processing return value of vp hooks */
void vp_act(proc_virt_t *proc, virt_ctrl_t ret);

/* stop a virtual process by calling the stop hook and closing all fds
   (hard is ignored) */
void vp_stop(proc_virt_t *proc, int hard);

